#!/usr/local/bin/perl
#
# DBTL - 1.0
# Database Template Language
#
# (c) 1998 js <jonny@dillingen.baynet.de>

use DBI;
use CGI;
use IniConf;

# define constants
###################

$dbh = 0;
$query;
$cfg;
$ininame = "dbtl.ini";
$debug = 0;

# database-info
$db_host = "localhost";
$db_database = "test";
$db_user = "";
$db_pwd = "";
$db_driver = "mysql";

# functions
###################

sub connect {
	local($hostname, $db, $user, $pwd) = @_;

	$dbh = DBI->connect("dbi:$db_driver:$db:$hostname", $user, $pwd);
}

sub doquery {
	local($myquery) = @_;

	$dbh->do($myquery);
}

sub selquery {
	local($myquery) = @_;
	local($sth);

	$sth = $dbh->prepare($myquery);
	$sth->execute();

	return $sth;
}

sub getsqlhash {
	(local $myquery) = @_;
	(local $sels, @line, $sth);
	(local %sels) = ();

	$sth = $dbh->prepare($myquery);
	$sth->execute();

	while(@line = $sth->fetchrow_array()) {
		$sels{$line[0]} = $line[1];
	}

	$sth->finish;

	return %sels;
}

sub getsqllist_oned {
    (local $myquery) = @_;
    (local @sels, $sels, $i, $line, $sth);
    
    print "getsqllist_oned: ", $myquery, "\n";
    $sth = $dbh->prepare($myquery);
    $sth->execute();

    $i = 0;
    while($line = $sth->fetchrow_array())
    {
	if($line) 
	{
	    @sels[$i++] = $line;
	}
    }

    return $sels;
}

sub getsql_sth {
    local ($myquery) = @_;
    local ($sth);

    #print "getsql_sth: ", $myquery, "\n";
    $sth = $dbh->prepare($myquery);
    $sth->execute();

    return $sth;
}

sub getsqllist {
    (local $myquery) = @_;
    (local $sels, @sels, $i, $line, $sth);
    
    print "Query: ", $myquery, "\n";
    $sth = $dbh->prepare($myquery);
    $sth->execute();
    
    $i = 0;
    while($line = $sth->fetchrow_array()) {
	if($line) {
	    @sels[$i++] = $line;
	}
    }
    
    $sth->finish;
    
    return $sels;
}

sub parsedoutput {
    local($file) = @_;

    # Datei einlesen
    open FILE, $file;
    $maxline = 0;
    while(<FILE>) {
	$program[$maxline++] = $_;
	#print $program[$maxline-1];
    }
    close FILE;

    # Programm abarbeiten
    $whileactive = 0;
    $jumpactive = 0;
    &parseloop();
}

sub parseloop {
    for($pcounter=0; $pcounter<$maxline; ) {
	&doparse();
    }
}

sub doparse {
    local($zeile) = @_;
    local($argstr, %args, $tag, $ttag, $argleft, $argright, $input);
    local($line);

    $zeile = $program[$pcounter++];

    if($debug) { print "PC: $pcounter => $zeile\n"; };
    
    while (($ttag) = ($zeile =~ /\{\s*(.*?\(.*?\))\}/))    # oldnew: /\{(\s*.*?\(.*\)\s*)\}/)) 
		                                               # old: /\{\s*(.*?)\s*\}/)) 
    {
	$input = '';
	
	# get the tag itself
	($tag, $argstr) = $ttag =~ /^(\w*)\s*\((.*)\)\s*$/;
	if($tag eq '') { $tag = $ttag; };
	$tag = uc $tag;
	
	# parse arg-str
	%args = ();
	while ($argstr =~ /\s*(.*?)\s*=\s*(.*?)\s*;/)
	{
	    $argleft = uc $1;
	    $argright = $2;
	    $args{$argleft} = $argright;
	    $argstr =~ s/(.*?);//i;
	}
	if($argstr =~ /\s*(.*?)\s*=\s*(.*?)\s*$/) {
	    $argleft = uc $1;
	    $argright = $2;
	    $args{$argleft} = $argright;
	    $argstr = '';
	}
	
	######################
	# Verarbeitung von TAG
	######################

	if($jumpactive) {
	    if(($tag ne 'LABEL') && ($args{'NAME'} ne $jumpdestination)) { return; }
	    else {
		$jumpactive = 0;
	    }
	}
	
	# While-Schleife
	if($tag eq '#') {
	    return;
	}
	if($tag eq 'LABEL') {
	    $labels{$args{'NAME'}} = $pcounter-1;
	}
	if($tag eq 'GOTO') {
	    if($labels{$args{'LABEL'}}) { $pcounter = $labels{$args{'LABEL'}} - 1; return; };
	    $jumpactive = 1;
	    $jumpdestination = $args{'LABEL'};
	}
	if($tag eq 'ENDWHILE') {
	    $endwhile = $pcounter+1;
	    $pcounter = $startwhile;
	    &doparse();
	    return;
	}
	if($tag eq 'WHILE') {
	    $startwhile = $pcounter-1;
	    if($debug) { print "EVAL: $args{'CONDITION'}<br>\n"; };	    
	    $jumpactive = 1;
	    if(eval($args{'CONDITION'}))
	    {
		$whileactive = 1;
		&doparse();
		return;
	    }
	    else {
		if($whileactive)
		{
		    $pcounter = $endwhile;
		    &doparse();
		}
		else
		{
		    $jumpactive = 1;
		    $jumpdestination = 'ENDWHILE';
		}
	    }
	}
	if($tag eq 'SQLQUERY') {
	    $squery = $args{'QUERY'};
	    if($args{'QID'}) {
		$qid = $args{'QID'};
	    } else { $qid = 0; };
	    if($debug) { print "QUERY: $squery, QID: $qid\n"; };
	    # construct the query
	    while($squery =~ /(.*?)\$(\w*)(\W*)(.*)$/)
	    {
		$part = $2;
		$npart = $query->param($part);
		#$npart = eval("\$" . $part);
		$squery =~ s/\$$part/$npart/i;
		#print "part: $part, npart: $npart, query: $squery\n";
	    }
	    # query ready :-)
	    if($sth[$qid]) { $sth[$qid]->finish(); };
	    $sth[$qid] = &getsql_sth($squery);
	    $numrows[$qid] = $sth[$qid]->{NUMROWS};
	    if($debug) { print "NUMROWS: $numrows\n"; };
	    $sqlresult[$qid] = $sth[$qid]->fetchrow_hashref;
	    $sqlrow[$qid] = 1;
	}
	if($tag eq 'SQLNEXTROW') {
	    if($args{'QID'}) {
		$qid = $args{'QID'};
	    } else { $qid = 0; };
	    $sqlresult[$qid] = $sth[$qid]->fetchrow_hashref;
	    $sqlrow[$qid]++;
	}
	if($tag eq 'SQLPRINT') {
	    if($args{'QID'}) {
		$qid = $args{'QID'};
	    } else { $qid = 0; };
	    $input = $sqlresult[$qid]->{$args{'FIELD'}};
	}
	if($tag eq 'NEWTEMPLATE') {
	    $template = $sqlresult[$qid]->{'template'};
	    &parsedoutput($template);
	    exit;
	}
	if($tag eq 'IF') {
	    if(eval($args{'CONDITION'})) {
		eval($args{'IF'});
	    }
	    else { eval($args{'ELSE'}); }
	}
	if($tag eq 'VAR') {
	    $vars{$args{'NAME'}} = $args{'VALUE'};
	}
	if($tag eq 'SQLVAL') {
	    if($args{'QID'}) {
		$qid = $args{'QID'};
	    } else { $qid = 0; };
	    $vars{$args{'NAME'}} = $sqlresult[$qid]->{$args{'FIELD'}};
	}
	if($tag eq 'PRINT') {
	    $input = $vars{$args{'VAR'}};
	}
	if($tag eq 'PPRINT') {
	    $input = eval($args{'VAR'});
	}
	$zeile =~ s/\{.*?\(.*?\)\}/$input/i;
    }
    print $zeile;
}

sub fehler {
	my($header, $text) = @_;
        print $query->start_html(-title=>'Fehler!');
        print $query->h1($header);
	print $text;
        print $query->end_html;
        exit;
}

sub main {
    print $query->header();
    
    if(-r $ininame)
    {
	$cfg = new IniConf -file=>$ininame;
	&fehler("Syntaxfehler in " . $ininame . ": ".
		$IniConf::errors[0]) if ($IniConf::errors[0]);
    }
    
    # connect to database
    &connect($db_host, $db_database, $db_user, $db_pwd);

    $action = $query->param('action');

    if($action eq '') {
	$template = $cfg->val('templates', 'default');
    }
    else {
	$template = $cfg->val('templates', $action);
    }

    if($template eq '') {
	&fehler('template unknown!', 'The specified template is unknown. Please check the\
 ini-file. Make sure you have an entry for the template "default"!');
    }

    if(!(-r $template)) {
	&fehler('file not found!', "The template html-file ($template) does not exist!");
    }
    
    &parsedoutput($template);
}

$query = new CGI;
&main();
